/* MailTweak internal component - Copyright (C) 2007 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://journal.mozdev.org/mailtweak.html */
function NSGetModule(compMgr, fileSpec) {
return mailtweakModule}
var mailtweakModule = {
CID: Components.ID("{8547513e-4f5a-11dc-8314-f800200c9a6b}"),contractID: "@rod.whiteley/mailtweak;1",className: "MailTweak",registerSelf: function (mgr, file, loc, type) {
mgr.QueryInterface(Components.interfaces.nsIComponentRegistrar).registerFactoryLocation(this.CID, this.className, this.contractID, file, loc, type)
Components.classes["@mozilla.org/categorymanager;1"].getService(Components.interfaces.nsICategoryManager).addCategoryEntry("app-startup", this.className, "service," + this.contractID, true, true, null)},getClassObject: function (aComponentManager, aCID, aIID) {
if (!aIID.equals(Components.interfaces.nsIFactory))
throw Components.results.NS_ERROR_NOT_IMPLEMENTED
if (!aCID.equals(this.CID))
throw Components.results.NS_ERROR_NO_INTERFACE
return this.factory},factory: {
createInstance: function (aOuter, aIID) {
if (aOuter != null) throw Components.results.NS_ERROR_NO_AGGREGATION
return MailTweakService}},canUnload: function () {return true}}
MailTweakService = {
obs: Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService),pref: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),prefBranch: null,_onetime: false,_cleanup: [],about: function (wdw, evt) {
var v0 = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager).getItemForID("mail-tweak@rod.whiteley").version
this._about = (this.prefBranch.getCharPref("version") != v0)
if (this._about) {
this.prefBranch.setCharPref("version", v0)
this._options = false
wdw.openDialog(
"chrome://mailtweak/content/about.xul","_blank","chrome,modal,centerscreen",this)
if (this._options) wdw.openDialog(
"chrome://mailtweak/content/options.xul","_blank","chrome,modal,centerscreen",null)}},_appliedURI: null,applyStyle: function () {
if (this._appliedURI) {
Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService).unregisterSheet(this._appliedURI, 0)
this._appliedURI = null}
var css = ""
if (this.prefBranch.getBoolPref("treefont")) {
var size = this.prefBranch.getIntPref("treefont.size")
if (size) css += "treechildren%7Bfont-size%3A" + String(size) + "px%3B%7D"}
if (css) {
this._appliedURI = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI("data:text/css," + css, "", null)
Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService).loadAndRegisterSheet(this._appliedURI, 0)}},observe: function (subject, topic, data) {
switch (topic) {
case "app-startup":
this.obs.addObserver(this, "domwindowopened", false)
this.obs.addObserver(this, "em-action-requested", false)
break;
case "domwindowopened":
subject.MailTweakService = this
if (this._onetime) return
else this._onetime = true
var pf = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("PrefD", Components.interfaces.nsIFile)
pf.append("prefs.js")
this.pref.readUserPrefs(pf)
this.prefBranch = this.pref.getBranch("extension.mailtweak.")
this.applyStyle()
var self = this
var focus = function (event) {
event.target.removeEventListener("focus", focus, false)
self.about(subject, event)}
subject.addEventListener("load",function (event) {
var tt = event.target.getElementById("threadTree")
if (!tt) return
tt.addEventListener("focus", focus, false)},false)
break;
case "em-action-requested":
var item = subject.QueryInterface(Components.interfaces.nsIUpdateItem)
if (item.id != "mail-tweak@rod.whiteley") return
switch (data) {
case "item-disabled":
this._prefCache = null
case "item-uninstalled":
this._prefCache = []
var b = this.prefBranch
var cc = b.getChildList("", {})
for each (var c in cc) {
var t = b.getPrefType(c)
var v = (t == 32)? b.getCharPref(c) : (t == 64)? b.getIntPref(c) : b.getBoolPref(c)
this._prefCache.push({name: c, type: t, value: v})}
b.deleteBranch("")
break;
case "item-cancel-action":
if (!this._prefCache) return
var b = this.prefBranch
for each (var c in this._prefCache) {
if (c.type == 32) b.setCharPref(c.name, c.value)
else if (c.type == 64) b.setIntPref(c.name, c.value)
else b.setBoolPref(c.name, c.value)}
this._prefCache = null
break;}
break;}},reload: function (doMail, doAB, doComp) {
this.applyStyle()
var WW = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher)
var a = []
if (doMail) a.push({type: "mail:3pane", url: "chrome://messenger/content/messenger.xul"})
if (doAB) a.push({type: "mail:addressbook", url: "chrome://messenger/content/addressbook/addressbook.xul"})
if (doComp) a.push({type: "msgcompose", url: null})
for each (var spec in a) {
var enum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator).getEnumerator(spec.type)
while (enum.hasMoreElements()) {
const feat = "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar"
var w = enum.getNext()
if (spec.url && !enum.hasMoreElements())
WW.openWindow(null, spec.url, "_blank", feat, null )
w.close()}}},get personalizer () {return Personalizer},get disconnecter () {return Disconnecter},toString: function () {return "[object MailTweakService]"}}
Personalizer = {
IOS: Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService),MMS: Components.classes["@mozilla.org/messenger/services/session;1"].getService(Components.interfaces.nsIMsgMailSession),MSL: Components.classes["@mozilla.org/messengercompose/sendlater;1"].getService(Components.interfaces.nsIMsgSendLater),timer: Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer),make_active: false,activate: function (id) {
this._mark = MailTweakService.prefBranch.getCharPref("personal.marker")
this._uniqueid = MailTweakService.prefBranch.getBoolPref("personal.uniqueid")
this._umf = this.MSL.getUnsentMessagesFolder(id)
this._msgid = {}
var enum = this._umf.getMessages(null)
while (enum.hasMoreElements()) {
var msg = enum.getNext().QueryInterface(Components.interfaces.nsIMsgDBHdr)
this._msgid[msg.messageId] = true}
this._observercount = 50
this.timer.init(this, 100, 1)},observe: function () {
var enum = this._umf.getMessages(null)
while (enum.hasMoreElements()) {
var msg = enum.getNext().QueryInterface(Components.interfaces.nsIMsgDBHdr)
if (!this._msgid[msg.messageId]) {
this.timer.cancel()
this.process(msg)
break}}
if (--this._observercount == 0) this.timer.cancel()},process: function (msg) {
this._msg = msg
if (msg.Charset) {
this._charset = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter)
this._charset.charset = msg.Charset}
else this._charset = null
this._recipient = msg.recipients.split(",")
this._card = []
for (var i = 0; i < this._recipient.length; ++i) {
var adr = this._recipient[i].replace(/^.*\<|\>$/g, "")
try {this._card.push(this.abSearch(adr))}
catch (ex) {
this.error("abook", this._recipient[i])
return}}
var url = this.MMS.ConvertMsgURIToMsgURL(this._umf.generateMessageURI(msg.messageKey), null)
var cha = this.IOS.newChannel(url, "", null)
cha.asyncOpen(this.reader, null)},abSearch: function (addr) {
var abks = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService).GetResource("moz-abdirectory://").QueryInterface(Components.interfaces.nsIAbDirectory).childNodes
while (abks.hasMoreElements()) {
var abk = abks.getNext().QueryInterface(Components.interfaces.nsIAbDirectory)
if (!abk.isRemote && !abk.isMailList) {
var cds = abk.childCards
try {
cds.first()
while (true) {
var cd = cds.currentItem().QueryInterface(Components.interfaces.nsIAbCard)
if (cd.primaryEmail == addr) return cd
cds.next()}} catch (ex) {continue}}}
throw null},reader: {
onDataAvailable: function (req, ctx, ins, ofs, cnt) {
var sis = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream)
sis.init(ins)
Personalizer._eml += sis.read(sis.available())},onStartRequest: function () {Personalizer._eml = ""},onStopRequest: function () {Personalizer.clone()}},clone: function () {
this._eml = this._eml.replace(/\nTo:.*\r(\n\s.*\r)*/i, "\nTo: " + this._mark + "_fullEmail" + this._mark + "\r").replace(/\nCC:.*\r/i, "").replace(/\nBCC:.*\r(\n\s.*\r)*/i, "\nBCC: " + this._mark + "_fullEmail" + this._mark + "\r")
for (var i = 0; i < this._card.length; ++i) this.clone1(i)
this._umf.getDBFolderInfoAndDB({}).DeleteMessage(this._msg.messageKey, null, true)
var PS = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService)
var send = PS.confirmEx(
null,this.string("label"),this.string("sendnow").replace(/#/, this._card.length),0x7F7F,this.string("sendbtn"),this.string("leavebtn"),"",null,{})
if (send == 0) this.MSL.SendUnsentMessages(this._identity)},clone1: function (n) {
var sis = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream)
var text = this.modify(this._eml, n)
var eml = {
inputStream: sis,openStreamForReading: function () {sis.setData(text, text.length)},closeStream: function () {sis.close()},QueryInterface: function (iid) {
if (iid.equals(Components.interfaces.nsIFileSpec)
|| iid.equals(Components.interfaces.nsISupports))
return this
throw Components.results.NS_NOINTERFACE;}}
Components.classes["@mozilla.org/messenger/messagecopyservice;1"].createInstance(Components.interfaces.nsIMsgCopyService).CopyFileMessage(eml, this._umf, null, false, 0, null, null)},modify: function (eml, n) {
// also avoid processing fields in attachments!
var cs = this._charset
var mk = this._mark
var text = eml
var tok = eml.match(new RegExp(mk + "\\w+" + mk, "g"))
var rmv = new RegExp(mk, "g")
for (var i = 0; i < tok.length; ++i) {
var sub = this._card[n][tok[i].replace(rmv, "")] || ""
if (!sub && tok[i] == this._mark + "_fullEmail" + this._mark) sub = this._recipient[n]
if (cs) sub = cs.ConvertFromUnicode(sub)
text = text.replace(new RegExp(tok[i], "g"), sub)}
if (this._uniqueid) {
var m = text.match(/Message-ID: (\S+)/)
if (m) {
var id = m[1].replace(/@/, "." + n + "@")
text = text.replace(/Message-ID: (\S+)/, "Message-ID: " + id)}}
return text},error: function (msg, sub) {
var PS = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService)
PS.alert(
null,this.string("error"),this.string(msg).replace(/#/, sub) + "\n" + this.string("unsent"))},_strings: null,string: function (key) {
if (!this._strings) this._strings = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService).createBundle("chrome://mailtweak/locale/compose.properties")
return this._strings.GetStringFromName(key)},toString: function () {return "[object MailTweak Personalizer]"}}
Disconnecter = {
enabled: true,_tally: 0,_timer: Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer),await: function (state) {
if (state == "true") {
if (this._tally == 0) return
if (--this._tally == 0) this._timer.init(
this,MailTweakService.prefBranch.getIntPref("disconnect.delay") * 1000,0)}
else {
this._timer.cancel()
this._tally++}},observe: function () {
if (!Disconnecter.enabled) return
var DS = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties)
var name = MailTweakService.prefBranch.getCharPref("disconnect.script")
var scr = DS.get("PrefD", Components.interfaces.nsIFile).parent
scr.append(name)
if (!scr.exists()) {
scr = DS.get("ARes", Components.interfaces.nsIFile)
scr.append(name)}
if (scr.exists()) try {
var proc = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess)
proc.init(scr)
proc.run(false, null, 0)} catch (ex) {}
if (MailTweakService.prefBranch.getBoolPref("disconnect.offline")) {
var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher).getWindowEnumerator()
while (ww.hasMoreElements()) {
var w = ww.getNext().QueryInterface(Components.interfaces.nsIDOMWindow)
if ("MailOfflineMgr" in w) {
if (w.MailOfflineMgr.isOnline()) w.MailOfflineMgr.toggleOfflineStatus()
break}}}}}